/*
    VB (Visual Basic) Process Killer
    Copyright (C) 2006 Yohanes Nugroho

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/
#include <windows.h>
#include <tlhelp32.h>
#include <stdio.h>

BOOL DependsOnVB (DWORD dwPID, char *modname, int length)
{ 
    BOOL          bRet        = FALSE; 
    HANDLE        hModuleSnap = NULL; 
    MODULEENTRY32 me32        = {0};
    char fname[MAX_PATH];
 
    hModuleSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwPID); 
    if (hModuleSnap == INVALID_HANDLE_VALUE) {
      // printf("%ld\n", GetLastError());
        return (FALSE); 
    }
 
    memset(&me32, 0, sizeof(MODULEENTRY32));
    me32.dwSize = sizeof(MODULEENTRY32); 
    bRet = FALSE;
 
    if (Module32First(hModuleSnap, &me32)) 
      { 
	int i = 0;
        do 
	  {
	    strncpy(fname, me32.szExePath, sizeof(fname));
	    _strupr(fname); /*this function is from msvcrt*/
	    if (strstr(fname, "MSVBVM")) {
		
		bRet = TRUE;
		break;
	    }
	    if (i==0 && modname) strncpy(modname, me32.szExePath, length);
	    i++;
        } 
        while (Module32Next(hModuleSnap, &me32)); 

    } 
    else {
        bRet = FALSE;
    }
    CloseHandle (hModuleSnap); 
    return (bRet); 
}

int KillVB () 
{ 
    HANDLE         hProcessSnap = NULL; 
    PROCESSENTRY32 pe32      = {0}; 
    char fname[MAX_PATH];
    int killed = 0;

    hProcessSnap = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); 

    if (hProcessSnap == INVALID_HANDLE_VALUE) {
        return (0); 
    }
    pe32.dwSize = sizeof(PROCESSENTRY32); 
    if (Process32First(hProcessSnap, &pe32)) 
    { 
        BOOL          bDependsOnVB = FALSE; 
        do  { 
	  bDependsOnVB = DependsOnVB(pe32.th32ProcessID, fname, sizeof(fname));
	    if ( bDependsOnVB) {
	      printf("Trying to kill %s\n", fname);
	      HANDLE h = OpenProcess(PROCESS_TERMINATE, 0, pe32.th32ProcessID);
	      if (h==NULL) {
		printf("Error %ld\n", GetLastError());
	      }  else {		
		if (!TerminateProcess(h, 0)){
		  printf("Error killing process. Error code =  %ld\n", 
			 GetLastError());
		} else {
		  killed++;
		}
	      }
	      CloseHandle(h);
	    }
        } 
        while (Process32Next(hProcessSnap, &pe32)); 
    } 
    else {
      printf("Failed to obtain process list\n");
      return 0;
    }
    CloseHandle (hProcessSnap); 
    return (killed); 
}

int main()
{
  printf("VB Process Killer\n");
  printf("Copyright (c) 2006 Yohanes Nugroho (yohanes@gmail.com)\n");
  printf("http://www.compactbyte.com, http://blog.compactbyte.com\n");
  printf("%d process(es) killed\n", KillVB());
  system("pause");
  return 0;
}
